<template>
  <v-container class="fill-height container--fluid justify-center align-start">
    <error-dialog :dialog="dialog" :error="error" @close-dialog="closeDialog" />
    <v-row class="justify-start " style="max-width: 80vw">
      <h1 class="heading primary--text display-3" v-if="!edit" @dblclick="edit = true">
        {{dao.title ? dao.title : 'Double click here to change title'}}
      </h1>
      <v-text-field
        v-else
        v-model="dao.title"
        counter
        maxlength="512"
        outlined
        @blur="edit = false"
        @keyup.enter="edit = false"
      ></v-text-field>
    </v-row>
    <v-row class="justify-center" style="max-width: 80vw">
      <v-textarea
        outlined
        v-model="dao.content"
        rows="30"
        row-height="15"
        :rules="[sizeRule]"
        :hint="`${contentSize} bytes`"
      ></v-textarea>
    </v-row>
    <v-row class="justify-center" style="max-width: 80vw">
      <v-btn @click="paste"
             color="primary"
             :loading="loading"
             :disabled="loading"
             block
      >
        Create New Paste
      </v-btn>
    </v-row>
    <v-row class="justify-center mt-5">
      <table>
        <thead>
          <tr>
            <th v-for="(key,idx) in headers" :key="idx">
              {{ key.text }}
            </th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(entry,idx) in pastes" :key="idx">
            <td v-for="(key,i) in headers" :key="i">
              {{entry[key.value]}}
            </td>
          </tr>
        </tbody>
      </table>
    </v-row>
  </v-container>
</template>

<script>
import ErrorDialog from '@/components/ErrorDialog.vue';
import { createPaste, recents } from '../api';

export default {
  name: 'home',
  components: { ErrorDialog },
  data: () => ({
    headers: [
      { text: 'Title', value: 'title' },
      { text: 'Content', value: 'content' },
      { text: 'Created At', value: 'createdAt' },
    ],
    pastes: [],
    dao: {
      title: '',
      content: '',
    },
    id: null,
    contentSize: 0,
    edit: false,
    dialog: false,
    fetching: false,
    loading: false,
    error: '',
  }),
  watch: {
    'dao.content': function (val) {
      this.contentSize = new Blob([val]).size;
    },
  },
  mounted() {
    this.fetchRecents();
  },
  methods: {
    fetchRecents() {
      this.fetching = true;
      recents()
        .then(({ data }) => {
          this.pastes = data;
          this.fetching = false;
        })
        .catch(({ data }) => {
          this.fetching = false;
          this.dialog = true;
          this.error = data.error;
        });
    },
    sizeRule(content) {
      return new Blob([content]).size < (2 ** 16);
    },
    isValid(dao) {
      return dao.title.length <= 512 && new Blob([dao.content]).size < (2 ** 16);
    },
    paste() {
      if (!this.dao.title) {
        this.dialog = true;
        this.error = 'title should not be empty';
      } else if (this.isValid(this.dao)) {
        this.loading = true;
        createPaste(this.dao)
          .then(({ data }) => {
            this.loading = false;
            this.id = data.id;
            this.$router.push({
              name: 'paste',
              params: { id: this.id },
            });
          })
          .catch(({ data }) => {
            this.loading = false;
            this.dialog = true;
            this.error = data.error;
          });
      } else {
        this.dialog = true;
        this.error = 'content is too long';
      }
    },
    closeDialog() {
      this.dialog = false;
      this.error = '';
    },
  },
};
</script>
